Index: EcnlProtoTool/trunk/prototool/.Debuglinker
===================================================================
--- EcnlProtoTool/trunk/prototool/.Debuglinker	(revision 447)
+++ 	(revision )
@@ -1,95 +1,0 @@
-<?xml version="1.0" encoding="ASCII"?>
-<com.renesas.linkersection.model:SectionContainer xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:com.renesas.linkersection.model="http:///LinkerSection.ecore">
-  <sections name=".boot" isKeep="true">
-    <sectionAddress xsi:type="com.renesas.linkersection.model:FixedAddress" fixedAddress="402653184"/>
-    <contents xsi:type="com.renesas.linkersection.model:WildCardExpression" specificSection="true" name=".boot"/>
-  </sections>
-  <sections name=".fvectors" isKeep="true">
-    <sectionAddress xsi:type="com.renesas.linkersection.model:FixedAddress" fixedAddress="404750336"/>
-    <contents xsi:type="com.renesas.linkersection.model:WildCardExpression" specificSection="true" name=".fvectors"/>
-  </sections>
-  <sections name=".text">
-    <sectionAddress xsi:type="com.renesas.linkersection.model:FixedAddress" fixedAddress="404750592"/>
-    <contents xsi:type="com.renesas.linkersection.model:WildCardExpression" specificSection="true" name=".text"/>
-    <contents xsi:type="com.renesas.linkersection.model:WildCardExpression" specificSection="true" name=".text.*"/>
-  </sections>
-  <sections name=".rvectors" isKeep="true">
-    <sectionAddress xsi:type="com.renesas.linkersection.model:ReferencedSectionAddress" referencedSection="//@sections.2"/>
-    <contents xsi:type="com.renesas.linkersection.model:Label" rhs="= .;" lhs="_rvectors_start"/>
-    <contents xsi:type="com.renesas.linkersection.model:WildCardExpression" specificSection="true" name=".rvectors"/>
-    <contents xsi:type="com.renesas.linkersection.model:Label" rhs="= .;" lhs="_rvectors_end"/>
-  </sections>
-  <sections name=".init">
-    <sectionAddress xsi:type="com.renesas.linkersection.model:ReferencedSectionAddress" referencedSection="//@sections.3"/>
-    <contents xsi:type="com.renesas.linkersection.model:WildCardExpression" specificSection="true" name=".init"/>
-    <contents xsi:type="com.renesas.linkersection.model:Keyword" text="PROVIDE_HIDDEN (__exidx_start = .)"/>
-    <contents xsi:type="com.renesas.linkersection.model:Keyword" text="PROVIDE_HIDDEN (__exidx_end = .)"/>
-  </sections>
-  <sections name=".fini">
-    <sectionAddress xsi:type="com.renesas.linkersection.model:ReferencedSectionAddress" referencedSection="//@sections.4"/>
-    <contents xsi:type="com.renesas.linkersection.model:WildCardExpression" specificSection="true" name=".fini"/>
-  </sections>
-  <sections name=".got">
-    <sectionAddress xsi:type="com.renesas.linkersection.model:ReferencedSectionAddress" referencedSection="//@sections.5"/>
-    <contents xsi:type="com.renesas.linkersection.model:WildCardExpression" specificSection="true" name=".got"/>
-    <contents xsi:type="com.renesas.linkersection.model:WildCardExpression" specificSection="true" name=".got.plt"/>
-  </sections>
-  <sections name=".rodata">
-    <sectionAddress xsi:type="com.renesas.linkersection.model:ReferencedSectionAddress" referencedSection="//@sections.6"/>
-    <contents xsi:type="com.renesas.linkersection.model:WildCardExpression" specificSection="true" name=".rodata"/>
-    <contents xsi:type="com.renesas.linkersection.model:WildCardExpression" specificSection="true" name=".rodata.*"/>
-    <contents xsi:type="com.renesas.linkersection.model:Label" rhs="= .;" lhs="_erodata"/>
-  </sections>
-  <sections name=".eh_frame_hdr">
-    <sectionAddress xsi:type="com.renesas.linkersection.model:ReferencedSectionAddress" referencedSection="//@sections.7"/>
-    <contents xsi:type="com.renesas.linkersection.model:WildCardExpression" specificSection="true" name=".eh_frame_hdr"/>
-  </sections>
-  <sections name=".eh_frame">
-    <sectionAddress xsi:type="com.renesas.linkersection.model:ReferencedSectionAddress" referencedSection="//@sections.8"/>
-    <contents xsi:type="com.renesas.linkersection.model:WildCardExpression" specificSection="true" name=".eh_frame"/>
-  </sections>
-  <sections name=".jcr">
-    <sectionAddress xsi:type="com.renesas.linkersection.model:ReferencedSectionAddress" referencedSection="//@sections.9"/>
-    <contents xsi:type="com.renesas.linkersection.model:WildCardExpression" specificSection="true" name=".jcr"/>
-  </sections>
-  <sections name=".tors">
-    <sectionAddress xsi:type="com.renesas.linkersection.model:ReferencedSectionAddress" referencedSection="//@sections.10"/>
-    <contents xsi:type="com.renesas.linkersection.model:Label" rhs="= .;" lhs="__CTOR_LIST__"/>
-    <contents xsi:type="com.renesas.linkersection.model:Keyword" text=". = ALIGN(2)"/>
-    <contents xsi:type="com.renesas.linkersection.model:Label" rhs="= .;" lhs="__ctors"/>
-    <contents xsi:type="com.renesas.linkersection.model:WildCardExpression" specificSection="true" name=".ctors"/>
-    <contents xsi:type="com.renesas.linkersection.model:Label" rhs="= .;" lhs="__ctors_end"/>
-    <contents xsi:type="com.renesas.linkersection.model:Label" rhs="= .;" lhs="__CTOR_END__"/>
-    <contents xsi:type="com.renesas.linkersection.model:Label" rhs="= .;" lhs="__DTOR_LIST__"/>
-    <contents xsi:type="com.renesas.linkersection.model:Label" rhs="= .;" lhs="___dtors"/>
-    <contents xsi:type="com.renesas.linkersection.model:WildCardExpression" specificSection="true" name=".dtors"/>
-    <contents xsi:type="com.renesas.linkersection.model:Label" rhs="= .;" lhs="___dtors_end"/>
-    <contents xsi:type="com.renesas.linkersection.model:Label" rhs="= .;" lhs="__DTOR_END__"/>
-    <contents xsi:type="com.renesas.linkersection.model:Keyword" text=". = ALIGN(2)"/>
-    <contents xsi:type="com.renesas.linkersection.model:Label" rhs="= .;" lhs="_mdata"/>
-  </sections>
-  <sections name=".data">
-    <sectionAddress xsi:type="com.renesas.linkersection.model:FixedAddress" fixedAddress="537919488"/>
-    <contents xsi:type="com.renesas.linkersection.model:Label" rhs="= .;" lhs="_data"/>
-    <contents xsi:type="com.renesas.linkersection.model:WildCardExpression" specificSection="true" name=".data"/>
-    <contents xsi:type="com.renesas.linkersection.model:WildCardExpression" specificSection="true" name=".data.*"/>
-    <contents xsi:type="com.renesas.linkersection.model:Label" rhs="= .;" lhs="_edata"/>
-    <reservedMemAddress xsi:type="com.renesas.linkersection.model:ReferencedLabelAddress" label="//@sections.11/@contents.12"/>
-  </sections>
-  <sections name=".bss">
-    <sectionAddress xsi:type="com.renesas.linkersection.model:ReferencedSectionAddress" referencedSection="//@sections.12"/>
-    <contents xsi:type="com.renesas.linkersection.model:Keyword" text="PROVIDE(__bss_start__ = .)"/>
-    <contents xsi:type="com.renesas.linkersection.model:Label" rhs="= .;" lhs="_bss"/>
-    <contents xsi:type="com.renesas.linkersection.model:WildCardExpression" specificSection="true" name=".bss"/>
-    <contents xsi:type="com.renesas.linkersection.model:WildCardExpression" specificSection="true" name=".bss.**"/>
-    <contents xsi:type="com.renesas.linkersection.model:WildCardExpression" specificSection="true" name="COMMON"/>
-    <contents xsi:type="com.renesas.linkersection.model:Keyword" text="PROVIDE(__bss_end__ = .)"/>
-    <contents xsi:type="com.renesas.linkersection.model:Label" rhs="= .;" lhs="_ebss"/>
-    <contents xsi:type="com.renesas.linkersection.model:Label" rhs="= .;" lhs="_end"/>
-    <contents xsi:type="com.renesas.linkersection.model:Keyword" text="PROVIDE(end = .)"/>
-  </sections>
-  <sections name=".stack" isNoLoad="true" isKeep="true">
-    <sectionAddress xsi:type="com.renesas.linkersection.model:FixedAddress" fixedAddress="543162368"/>
-    <contents xsi:type="com.renesas.linkersection.model:Label" rhs="= .;" lhs="_stack"/>
-  </sections>
-</com.renesas.linkersection.model:SectionContainer>