Index: asp_wio_terminal/trunk/target/samd51_gcc/target_vector.c
===================================================================
--- asp_wio_terminal/trunk/target/samd51_gcc/target_vector.c	(revision 460)
+++ 	(revision )
@@ -1,223 +1,0 @@
-/*
- *  TOPPERS/ASP Kernel
- *      Toyohashi Open Platform for Embedded Real-Time Systems/
- *      Advanced Standard Profile Kernel
- *
- *  Copyright (C) 2015 by Embedded and Real-Time Systems Laboratory
- *              Graduate School of Information Science, Nagoya Univ., JAPAN  
- * 
- *  ä¸è¨èä½æ¨©è
-ã¯ï¼ä»¥ä¸ã®(1)ï½(4)ã®æ¡ä»¶ãæºããå ´åã«éãï¼æ¬ã½ããã¦ã§
- *  ã¢ï¼æ¬ã½ããã¦ã§ã¢ãæ¹å¤ãããã®ãå«ãï¼ä»¥ä¸åãï¼ãä½¿ç¨ã»è¤è£½ã»æ¹
- *  å¤ã»åé
-å¸ï¼ä»¥ä¸ï¼å©ç¨ã¨å¼ã¶ï¼ãããã¨ãç¡åã§è¨±è«¾ããï¼
- *  (1) æ¬ã½ããã¦ã§ã¢ãã½ã¼ã¹ã³ã¼ãã®å½¢ã§å©ç¨ããå ´åã«ã¯ï¼ä¸è¨ã®èä½
- *      æ¨©è¡¨ç¤ºï¼ãã®å©ç¨æ¡ä»¶ããã³ä¸è¨ã®ç¡ä¿è¨¼è¦å®ãï¼ãã®ã¾ã¾ã®å½¢ã§ã½ã¼
- *      ã¹ã³ã¼ãä¸­ã«å«ã¾ãã¦ãããã¨ï¼
- *  (2) æ¬ã½ããã¦ã§ã¢ãï¼ã©ã¤ãã©ãªå½¢å¼ãªã©ï¼ä»ã®ã½ããã¦ã§ã¢éçºã«ä½¿
- *      ç¨ã§ããå½¢ã§åé
-å¸ããå ´åã«ã¯ï¼åé
-å¸ã«ä¼´ããã­ã¥ã¡ã³ãï¼å©ç¨
- *      è
-ããã¥ã¢ã«ãªã©ï¼ã«ï¼ä¸è¨ã®èä½æ¨©è¡¨ç¤ºï¼ãã®å©ç¨æ¡ä»¶ããã³ä¸è¨
- *      ã®ç¡ä¿è¨¼è¦å®ãæ²è¼ãããã¨ï¼
- *  (3) æ¬ã½ããã¦ã§ã¢ãï¼æ©å¨ã«çµã¿è¾¼ããªã©ï¼ä»ã®ã½ããã¦ã§ã¢éçºã«ä½¿
- *      ç¨ã§ããªãå½¢ã§åé
-å¸ããå ´åã«ã¯ï¼æ¬¡ã®ããããã®æ¡ä»¶ãæºããã
- *      ã¨ï¼
- *    (a) åé
-å¸ã«ä¼´ããã­ã¥ã¡ã³ãï¼å©ç¨è
-ããã¥ã¢ã«ãªã©ï¼ã«ï¼ä¸è¨ã®è
- *        ä½æ¨©è¡¨ç¤ºï¼ãã®å©ç¨æ¡ä»¶ããã³ä¸è¨ã®ç¡ä¿è¨¼è¦å®ãæ²è¼ãããã¨ï¼
- *    (b) åé
-å¸ã®å½¢æ
-ãï¼å¥ã«å®ããæ¹æ³ã«ãã£ã¦ï¼TOPPERSãã­ã¸ã§ã¯ãã«
- *        å ±åãããã¨ï¼
- *  (4) æ¬ã½ããã¦ã§ã¢ã®å©ç¨ã«ããç´æ¥çã¾ãã¯éæ¥çã«çãããããªãæ
- *      å®³ãããï¼ä¸è¨èä½æ¨©è
-ããã³TOPPERSãã­ã¸ã§ã¯ããå
-è²¬ãããã¨ï¼
- *      ã¾ãï¼æ¬ã½ããã¦ã§ã¢ã®ã¦ã¼ã¶ã¾ãã¯ã¨ã³ãã¦ã¼ã¶ããã®ãããªãç
- *      ç±ã«åºã¥ãè«æ±ãããï¼ä¸è¨èä½æ¨©è
-ããã³TOPPERSãã­ã¸ã§ã¯ãã
- *      å
-è²¬ãããã¨ï¼
- * 
- *  æ¬ã½ããã¦ã§ã¢ã¯ï¼ç¡ä¿è¨¼ã§æä¾ããã¦ãããã®ã§ããï¼ä¸è¨èä½æ¨©è
-ã
- *  ãã³TOPPERSãã­ã¸ã§ã¯ãã¯ï¼æ¬ã½ããã¦ã§ã¢ã«é¢ãã¦ï¼ç¹å®ã®ä½¿ç¨ç®ç
- *  ã«å¯¾ããé©åæ§ãå«ãã¦ï¼ãããªãä¿è¨¼ãè¡ããªãï¼ã¾ãï¼æ¬ã½ããã¦ã§
- *  ã¢ã®å©ç¨ã«ããç´æ¥çã¾ãã¯éæ¥çã«çãããããªãæå®³ã«é¢ãã¦ãï¼ã
- *  ã®è²¬ä»»ãè² ããªãï¼
- * 
- *  @(#) $Id: target_config.c 2697 2015-11-06 04:00:42Z ertl-honda $
- */
-
-/*
- * ãããä¾å­ãã¯ã¿ã¼ãã¼ãã«ï¼SAMD51ç¨ï¼
- */
-#include "kernel_impl.h"
-
- /*
-  *  ãã¯ã¿ãã¼ãã«
-  */
-__attribute__ ((aligned(0x400U)))
-__attribute__((section(".rodata.vector")))
-const  FP _kernel_vector_table[] =      
-{                                    
-	(FP)(NULL), /* 0 The initial stack pointer */
-	(FP)_start,           /* 1 The reset handler */
-	(FP)(core_exc_entry), /* 2 */
-	(FP)(core_exc_entry), /* 3 */
-	(FP)(core_exc_entry), /* 4 */
-	(FP)(core_exc_entry), /* 5 */
-	(FP)(core_exc_entry), /* 6 */
-	(FP)(core_exc_entry), /* 7 */
-	(FP)(core_exc_entry), /* 8 */
-	(FP)(core_exc_entry), /* 9 */
-	(FP)(core_exc_entry), /* 10 */
-	(FP)(svc_handler),    /* 11 SVCall handler */
-	(FP)(core_exc_entry), /* 12 */
-	(FP)(core_exc_entry), /* 13 */
-	(FP)(core_exc_entry), /* 14 */
-	(FP)(core_int_entry), /* 15 */
-	(FP)(core_int_entry), /* 16 */
-	(FP)(core_int_entry), /* 17 */
-	(FP)(core_int_entry), /* 18 */
-	(FP)(core_int_entry), /* 19 */
-	(FP)(core_int_entry), /* 20 */
-	(FP)(core_int_entry), /* 21 */
-	(FP)(core_int_entry), /* 22 */
-	(FP)(core_int_entry), /* 23 */
-	(FP)(core_int_entry), /* 24 */
-	(FP)(core_int_entry), /* 25 */
-	(FP)(core_int_entry), /* 26 */
-	(FP)(core_int_entry), /* 27 */
-	(FP)(core_int_entry), /* 28 */
-	(FP)(core_int_entry), /* 29 */
-	(FP)(core_int_entry), /* 30 */
-	(FP)(core_int_entry), /* 31 */
-	(FP)(core_int_entry), /* 32 */
-	(FP)(core_int_entry), /* 33 */
-	(FP)(core_int_entry), /* 34 */
-	(FP)(core_int_entry), /* 35 */
-	(FP)(core_int_entry), /* 36 */
-	(FP)(core_int_entry), /* 37 */
-	(FP)(core_int_entry), /* 38 */
-	(FP)(core_int_entry), /* 39 */
-	(FP)(core_int_entry), /* 40 */
-	(FP)(core_int_entry), /* 41 */
-	(FP)(core_int_entry), /* 42 */
-	(FP)(core_int_entry), /* 43 */
-	(FP)(core_int_entry), /* 44 */
-	(FP)(core_int_entry), /* 45 */
-	(FP)(core_int_entry), /* 46 */
-	(FP)(core_int_entry), /* 47 */
-	(FP)(core_int_entry), /* 48 */
-	(FP)(core_int_entry), /* 49 */
-	(FP)(core_int_entry), /* 50 */
-	(FP)(core_int_entry), /* 51 */
-	(FP)(core_int_entry), /* 52 */
-	(FP)(core_int_entry), /* 53 */
-	(FP)(core_int_entry), /* 54 */
-	(FP)(core_int_entry), /* 55 */
-	(FP)(core_int_entry), /* 56 */
-	(FP)(core_int_entry), /* 57 */
-	(FP)(core_int_entry), /* 58 */
-	(FP)(core_int_entry), /* 59 */
-	(FP)(core_int_entry), /* 60 */
-	(FP)(core_int_entry), /* 61 */
-	(FP)(core_int_entry), /* 62 */
-	(FP)(core_int_entry), /* 63 */
-	(FP)(core_int_entry), /* 64 */
-	(FP)(core_int_entry), /* 65 */
-	(FP)(core_int_entry), /* 66 */
-	(FP)(core_int_entry), /* 67 */
-	(FP)(core_int_entry), /* 68 */
-	(FP)(core_int_entry), /* 69 */
-	(FP)(core_int_entry), /* 70 */
-	(FP)(core_int_entry), /* 71 */
-	(FP)(core_int_entry), /* 72 */
-	(FP)(core_int_entry), /* 73 */
-	(FP)(core_int_entry), /* 74 */
-	(FP)(core_int_entry), /* 75 */
-	(FP)(core_int_entry), /* 76 */
-	(FP)(core_int_entry), /* 77 */
-	(FP)(core_int_entry), /* 78 */
-	(FP)(core_int_entry), /* 79 */
-	(FP)(core_int_entry), /* 80 */
-	(FP)(core_int_entry), /* 81 */
-	(FP)(core_int_entry), /* 82 */
-	(FP)(core_int_entry), /* 83 */
-	(FP)(core_int_entry), /* 84 */
-	(FP)(core_int_entry), /* 85 */
-	(FP)(core_int_entry), /* 86 */
-	(FP)(core_int_entry), /* 87 */
-	(FP)(core_int_entry), /* 88 */
-	(FP)(core_int_entry), /* 89 */
-	(FP)(core_int_entry), /* 90 */
-	(FP)(core_int_entry), /* 91 */
-	(FP)(core_int_entry), /* 92 */
-	(FP)(core_int_entry), /* 93 */
-	(FP)(core_int_entry), /* 94 */
-	(FP)(core_int_entry), /* 95 */
-	(FP)(core_int_entry), /* 96 */
-	(FP)(core_int_entry), /* 97 */
-	(FP)(core_int_entry), /* 98 */
-	(FP)(core_int_entry), /* 99 */
-	(FP)(core_int_entry), /* 100 */
-	(FP)(core_int_entry), /* 101 */
-	(FP)(core_int_entry), /* 102 */
-	(FP)(core_int_entry), /* 103 */
-	(FP)(core_int_entry), /* 104 */
-	(FP)(core_int_entry), /* 105 */
-	(FP)(core_int_entry), /* 106 */
-	(FP)(core_int_entry), /* 107 */
-	(FP)(core_int_entry), /* 108 */
-	(FP)(core_int_entry), /* 109 */
-	(FP)(core_int_entry), /* 110 */
-	(FP)(core_int_entry), /* 111 */
-	(FP)(core_int_entry), /* 112 */
-	(FP)(core_int_entry), /* 113 */
-	(FP)(core_int_entry), /* 114 */
-	(FP)(core_int_entry), /* 115 */
-	(FP)(core_int_entry), /* 116 */
-	(FP)(core_int_entry), /* 117 */
-	(FP)(core_int_entry), /* 118 */
-	(FP)(core_int_entry), /* 119 */
-	(FP)(core_int_entry), /* 120 */
-	(FP)(core_int_entry), /* 121 */
-	(FP)(core_int_entry), /* 122 */
-	(FP)(core_int_entry), /* 123 */
-	(FP)(core_int_entry), /* 124 */
-	(FP)(core_int_entry), /* 125 */
-	(FP)(core_int_entry), /* 126 */
-	(FP)(core_int_entry), /* 127 */
-	(FP)(core_int_entry), /* 128 */
-	(FP)(core_int_entry), /* 129 */
-	(FP)(core_int_entry), /* 130 */
-	(FP)(core_int_entry), /* 131 */
-	(FP)(core_int_entry), /* 132 */
-	(FP)(core_int_entry), /* 133 */
-	(FP)(core_int_entry), /* 134 */
-	(FP)(core_int_entry), /* 135 */
-	(FP)(core_int_entry), /* 136 */
-	(FP)(core_int_entry), /* 137 */
-	(FP)(core_int_entry), /* 138 */
-	(FP)(core_int_entry), /* 139 */
-	(FP)(core_int_entry), /* 140 */
-	(FP)(core_int_entry), /* 141 */
-	(FP)(core_int_entry), /* 142 */
-	(FP)(core_int_entry), /* 143 */
-	(FP)(core_int_entry), /* 144 */
-	(FP)(core_int_entry), /* 145 */
-	(FP)(core_int_entry), /* 146 */
-	(FP)(core_int_entry), /* 147 */
-	(FP)(core_int_entry), /* 148 */
-	(FP)(core_int_entry), /* 149 */
-	(FP)(core_int_entry), /* 150 */
-	(FP)(core_int_entry), /* 151 */
-	(FP)(core_int_entry), /* 152 */
-	(FP)(core_int_entry), /* 153 */
-	(FP)(core_int_entry), /* 154 */
-};