Index: azure_iot_hub_f767zi/trunk/app_iothub_client/.vscode/c_cpp_properties.json
===================================================================
--- azure_iot_hub_f767zi/trunk/app_iothub_client/.vscode/c_cpp_properties.json	(revision 465)
+++ azure_iot_hub_f767zi/trunk/app_iothub_client/.vscode/c_cpp_properties.json	(revision 466)
@@ -41,5 +41,5 @@
             ],
             "windowsSdkVersion": "10.0.17763.0",
-            "compilerPath": "C:\\Program Files (x86)\\GNU Tools ARM Embedded\\9 2019-q4-major\\bin\\arm-none-eabi-gcc.exe",
+            "compilerPath": "C:\\Program Files (x86)\\GNU Arm Embedded Toolchain\\10 2020-q4-major\\bin\\arm-none-eabi-gcc.exe",
             "cStandard": "c11",
             "cppStandard": "c++17",
Index: azure_iot_hub_f767zi/trunk/app_iothub_client/.vscode/launch.json
===================================================================
--- azure_iot_hub_f767zi/trunk/app_iothub_client/.vscode/launch.json	(revision 465)
+++ azure_iot_hub_f767zi/trunk/app_iothub_client/.vscode/launch.json	(revision 466)
@@ -4,5 +4,5 @@
         {
             "name": "Cortex Debug",
-            "armToolchainPath": "C:\\Program Files (x86)\\GNU Tools ARM Embedded\\9 2019-q4-major\\bin",
+            "armToolchainPath": "C:\\Program Files (x86)\\GNU Arm Embedded Toolchain\\10 2020-q4-major\\bin",
             "serverpath": "C:\\xpack-openocd-0.11.0-1\\bin\\openocd.exe",
             "cwd": "${workspaceFolder}\\Debug",
@@ -18,5 +18,6 @@
             ],
             "openOCDLaunchCommands": [
-                "gdb_breakpoint_override hard"
+                "gdb_breakpoint_override hard",
+                "gdb_memory_map disable"
             ],
             "preLaunchCommands": [
Index: azure_iot_hub_f767zi/trunk/app_iothub_client/.vscode/settings.json
===================================================================
--- azure_iot_hub_f767zi/trunk/app_iothub_client/.vscode/settings.json	(revision 465)
+++ azure_iot_hub_f767zi/trunk/app_iothub_client/.vscode/settings.json	(revision 466)
@@ -8,5 +8,5 @@
     ],
     "terminal.integrated.env.windows": {
-        "PATH": "C:\\Program Files (x86)\\GNU Tools ARM Embedded\\9 2019-q4-major\\bin",
+        "PATH": "C:\\Program Files (x86)\\GNU Arm Embedded Toolchain\\10 2020-q4-major\\bin",
         "CHERE_INVOKING": "1",
         "MSYS2_PATH_TYPE": "inherit",
Index: azure_iot_hub_f767zi/trunk/asp_baseplatform/.vscode/c_cpp_properties.json
===================================================================
--- azure_iot_hub_f767zi/trunk/asp_baseplatform/.vscode/c_cpp_properties.json	(revision 465)
+++ azure_iot_hub_f767zi/trunk/asp_baseplatform/.vscode/c_cpp_properties.json	(revision 466)
@@ -22,5 +22,5 @@
             ],
             "windowsSdkVersion": "10.0.17763.0",
-            "compilerPath": "C:\\Program Files (x86)\\GNU Tools ARM Embedded\\9 2019-q4-major\\bin\\arm-none-eabi-gcc.exe",
+            "compilerPath": "C:\\Program Files (x86)\\GNU Arm Embedded Toolchain\\10 2020-q4-major\\bin\\arm-none-eabi-gcc.exe",
             "cStandard": "c11",
             "cppStandard": "c++17",
Index: azure_iot_hub_f767zi/trunk/asp_baseplatform/.vscode/launch.json
===================================================================
--- azure_iot_hub_f767zi/trunk/asp_baseplatform/.vscode/launch.json	(revision 465)
+++ azure_iot_hub_f767zi/trunk/asp_baseplatform/.vscode/launch.json	(revision 466)
@@ -4,5 +4,5 @@
         {
             "name": "Cortex Debug",
-            "armToolchainPath": "C:\\Program Files (x86)\\GNU Tools ARM Embedded\\9 2019-q4-major\\bin",
+            "armToolchainPath": "C:\\Program Files (x86)\\GNU Arm Embedded Toolchain\\10 2020-q4-major\\bin",
             "serverpath": "C:\\xpack-openocd-0.11.0-1\\bin\\openocd.exe",
             "cwd": "${workspaceFolder}\\OBJ\\STM32F767NUCLEO144_GCC\\MAC",
@@ -18,5 +18,6 @@
             ],
             "openOCDLaunchCommands": [
-                "gdb_breakpoint_override hard"
+                "gdb_breakpoint_override hard",
+                "gdb_memory_map disable"
             ],
             "preLaunchCommands": [
Index: azure_iot_hub_f767zi/trunk/asp_baseplatform/.vscode/settings.json
===================================================================
--- azure_iot_hub_f767zi/trunk/asp_baseplatform/.vscode/settings.json	(revision 465)
+++ azure_iot_hub_f767zi/trunk/asp_baseplatform/.vscode/settings.json	(revision 466)
@@ -8,5 +8,5 @@
     ],
     "terminal.integrated.env.windows": {
-        "PATH": "C:\\Program Files (x86)\\GNU Tools ARM Embedded\\9 2019-q4-major\\bin",
+        "PATH": "C:\\Program Files (x86)\\GNU Arm Embedded Toolchain\\10 2020-q4-major\\bin",
         "CHERE_INVOKING": "1",
         "MSYS2_PATH_TYPE": "inherit",
Index: azure_iot_hub_f767zi/trunk/azure_iot_sdk/.vscode/c_cpp_properties.json
===================================================================
--- azure_iot_hub_f767zi/trunk/azure_iot_sdk/.vscode/c_cpp_properties.json	(revision 465)
+++ azure_iot_hub_f767zi/trunk/azure_iot_sdk/.vscode/c_cpp_properties.json	(revision 466)
@@ -30,5 +30,5 @@
             ],
             "windowsSdkVersion": "10.0.17763.0",
-            "compilerPath": "C:\\Program Files (x86)\\GNU Tools ARM Embedded\\9 2019-q4-major\\bin\\arm-none-eabi-gcc.exe",
+            "compilerPath": "C:\\Program Files (x86)\\GNU Arm Embedded Toolchain\\10 2020-q4-major\\bin\\arm-none-eabi-gcc.exe",
             "cStandard": "c11",
             "cppStandard": "c++17",
Index: azure_iot_hub_f767zi/trunk/azure_iot_sdk/.vscode/settings.json
===================================================================
--- azure_iot_hub_f767zi/trunk/azure_iot_sdk/.vscode/settings.json	(revision 465)
+++ azure_iot_hub_f767zi/trunk/azure_iot_sdk/.vscode/settings.json	(revision 466)
@@ -8,5 +8,5 @@
     ],
     "terminal.integrated.env.windows": {
-        "PATH": "C:\\Program Files (x86)\\GNU Tools ARM Embedded\\9 2019-q4-major\\bin",
+        "PATH": "C:\\Program Files (x86)\\GNU Arm Embedded Toolchain\\10 2020-q4-major\\bin",
         "CHERE_INVOKING": "1",
         "MSYS2_PATH_TYPE": "inherit",
Index: azure_iot_hub_f767zi/trunk/azure_iothub.code-workspace
===================================================================
--- azure_iot_hub_f767zi/trunk/azure_iothub.code-workspace	(revision 465)
+++ azure_iot_hub_f767zi/trunk/azure_iothub.code-workspace	(revision 466)
@@ -24,5 +24,5 @@
 		],
 		"terminal.integrated.env.windows": {
-			"PATH": "C:\\Program Files (x86)\\GNU Tools ARM Embedded\\9 2019-q4-major\\bin",
+			"PATH": "C:\\Program Files (x86)\\GNU Arm Embedded Toolchain\\10 2020-q4-major\\bin",
 			"CHERE_INVOKING": "1",
 			"MSYS2_PATH_TYPE": "inherit",
Index: azure_iot_hub_f767zi/trunk/wolfssl-4.7.0/.vscode/c_cpp_properties.json
===================================================================
--- azure_iot_hub_f767zi/trunk/wolfssl-4.7.0/.vscode/c_cpp_properties.json	(revision 465)
+++ azure_iot_hub_f767zi/trunk/wolfssl-4.7.0/.vscode/c_cpp_properties.json	(revision 466)
@@ -12,5 +12,5 @@
             ],
             "windowsSdkVersion": "10.0.17763.0",
-            "compilerPath": "C:\\Program Files (x86)\\GNU Tools ARM Embedded\\9 2019-q4-major\\bin\\arm-none-eabi-gcc.exe",
+            "compilerPath": "C:\\Program Files (x86)\\GNU Arm Embedded Toolchain\\10 2020-q4-major\\bin\\arm-none-eabi-gcc.exe",
             "cStandard": "c11",
             "cppStandard": "c++17",
Index: azure_iot_hub_f767zi/trunk/wolfssl-4.7.0/.vscode/settings.json
===================================================================
--- azure_iot_hub_f767zi/trunk/wolfssl-4.7.0/.vscode/settings.json	(revision 465)
+++ azure_iot_hub_f767zi/trunk/wolfssl-4.7.0/.vscode/settings.json	(revision 466)
@@ -8,5 +8,5 @@
     ],
     "terminal.integrated.env.windows": {
-        "PATH": "C:\\Program Files (x86)\\GNU Tools ARM Embedded\\9 2019-q4-major\\bin",
+        "PATH": "C:\\Program Files (x86)\\GNU Arm Embedded Toolchain\\10 2020-q4-major\\bin",
         "CHERE_INVOKING": "1",
         "MSYS2_PATH_TYPE": "inherit",
Index: azure_iot_hub_f767zi/trunk/zlib-1.2.11/.vscode/c_cpp_properties.json
===================================================================
--- azure_iot_hub_f767zi/trunk/zlib-1.2.11/.vscode/c_cpp_properties.json	(revision 465)
+++ azure_iot_hub_f767zi/trunk/zlib-1.2.11/.vscode/c_cpp_properties.json	(revision 466)
@@ -6,5 +6,5 @@
             ],
             "windowsSdkVersion": "10.0.17763.0",
-            "compilerPath": "C:\\Program Files (x86)\\GNU Tools ARM Embedded\\9 2019-q4-major\\bin\\arm-none-eabi-gcc.exe",
+            "compilerPath": "C:\\Program Files (x86)\\GNU Arm Embedded Toolchain\\10 2020-q4-major\\bin\\arm-none-eabi-gcc.exe",
             "cStandard": "c11",
             "cppStandard": "c++17",
Index: azure_iot_hub_f767zi/trunk/zlib-1.2.11/.vscode/settings.json
===================================================================
--- azure_iot_hub_f767zi/trunk/zlib-1.2.11/.vscode/settings.json	(revision 465)
+++ azure_iot_hub_f767zi/trunk/zlib-1.2.11/.vscode/settings.json	(revision 466)
@@ -8,5 +8,5 @@
     ],
     "terminal.integrated.env.windows": {
-        "PATH": "C:\\Program Files (x86)\\GNU Tools ARM Embedded\\9 2019-q4-major\\bin",
+        "PATH": "C:\\Program Files (x86)\\GNU Arm Embedded Toolchain\\10 2020-q4-major\\bin",
         "CHERE_INVOKING": "1",
         "MSYS2_PATH_TYPE": "inherit",